package testcases;

import java.io.IOException;
import java.util.Collections;
import java.util.Map;

import model.Book;
import model.BookType;
import model.Library;
import model.ModelFactory;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.junit.Test;

public class EMFTest {

	@Test
	public void testEmf() {
		Library lib = ModelFactory.eINSTANCE.createLibrary();
		Book book = ModelFactory.eINSTANCE.createBook();
		Book book2 = ModelFactory.eINSTANCE.createBook();
		lib.getBooks().add(book);
		lib.getBooks().add(book2);
		book.setType(BookType.ELECTRONICAL);

		Resource.Factory.Registry reg = Resource.Factory.Registry.INSTANCE;
		Map<String, Object> m = reg.getExtensionToFactoryMap();
		m.put("library", new XMIResourceFactoryImpl());

		ResourceSet resSet = new ResourceSetImpl();
		Resource resource = resSet.createResource(URI.createFileURI("/home/jpw/lib.library"));
		resource.getContents().add(lib);
		try {
			resource.save(Collections.EMPTY_MAP);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
